//***************************************
// GY-29 ADXL345 IICԳ
// ʹõƬSTC89C51 
// 11.0592M
// ʾLCD1602
// 뻷 Keil uVision2
// ο꾧վ24c04ͨų
// ʱ䣺201131
// QQ531389319
//****************************************
#include  <REG51.H>	
#include  <math.h>    //Keil library  
#include  <stdio.h>   //Keil library	
#include  <INTRINS.H>
#define   uchar unsigned char
#define   uint unsigned int	
#define   DataPort P0    //LCD1602ݶ˿
sbit	  SCL=P1^0;      //IICʱŶ
sbit 	  SDA=P1^1;      //IICŶ
sbit      LCM_RS=P2^0;   //LCD1602˿		
sbit      LCM_RW=P2^1;   //LCD1602˿		
sbit      LCM_EN=P2^2;   //LCD1602˿ 

#define	SlaveAddress   0xA6	  //IICеĴӵַ,ALT  ADDRESSַŲͬ޸
                              //ALT  ADDRESSŽӵʱַΪ0xA6ӵԴʱַΪ0x3A
typedef unsigned char  BYTE;
typedef unsigned short WORD;

BYTE BUF[8];                         //ݻ      	
uchar ge,shi,bai,qian,wan;           //ʾ
int  dis_data;                       //

void delay(unsigned int k);
void InitLcd();                      //ʼlcd1602
void Init_ADXL345(void);             //ʼADXL345

void WriteDataLCM(uchar dataW);
void WriteCommandLCM(uchar CMD,uchar Attribc);
void DisplayOneChar(uchar X,uchar Y,uchar DData);
void conversion(uint temp_data);

void  Single_Write_ADXL345(uchar REG_Address,uchar REG_data);   //д
uchar Single_Read_ADXL345(uchar REG_Address);                   //ȡڲĴ
void  Multiple_Read_ADXL345();                                  //ĶȡڲĴ
//------------------------------------
void Delay5us();
void Delay5ms();
void ADXL345_Start();
void ADXL345_Stop();
void ADXL345_SendACK(bit ack);
bit  ADXL345_RecvACK();
void ADXL345_SendByte(BYTE dat);
BYTE ADXL345_RecvByte();
void ADXL345_ReadPage();
void ADXL345_WritePage();
//-----------------------------------

//*********************************************************
void conversion(uint temp_data)  
{  
    wan=temp_data/10000+0x30 ;
    temp_data=temp_data%10000;   //ȡ
	qian=temp_data/1000+0x30 ;
    temp_data=temp_data%1000;    //ȡ
    bai=temp_data/100+0x30   ;
    temp_data=temp_data%100;     //ȡ
    shi=temp_data/10+0x30    ;
    temp_data=temp_data%10;      //ȡ
    ge=temp_data+0x30; 	
}

/*******************************/
void delay(unsigned int k)	
{						
unsigned int i,j;				
for(i=0;i<k;i++)
{			
for(j=0;j<121;j++)			
{;}}						
}
/*******************************/
void WaitForEnable(void)	
{					
DataPort=0xff;		
LCM_RS=0;LCM_RW=1;_nop_();
LCM_EN=1;_nop_();_nop_();
while(DataPort&0x80);	
LCM_EN=0;				
}					
/*******************************/
void WriteCommandLCM(uchar CMD,uchar Attribc)
{					
if(Attribc)WaitForEnable();	
LCM_RS=0;LCM_RW=0;_nop_();
DataPort=CMD;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}					
/*******************************/
void WriteDataLCM(uchar dataW)
{					
WaitForEnable();		
LCM_RS=1;LCM_RW=0;_nop_();
DataPort=dataW;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}		
/***********************************/
void InitLcd()				
{			
WriteCommandLCM(0x38,1);	
WriteCommandLCM(0x08,1);	
WriteCommandLCM(0x01,1);	
WriteCommandLCM(0x06,1);	
WriteCommandLCM(0x0c,1);
}			
/***********************************/
void DisplayOneChar(uchar X,uchar Y,uchar DData)
{						
Y&=1;						
X&=15;						
if(Y)X|=0x40;					
X|=0x80;			
WriteCommandLCM(X,0);		
WriteDataLCM(DData);		
}						

/**************************************
ʱ5΢(STC90C52RC@12M)
ͬĹ,Ҫ˺עʱӹʱҪ޸
1TMCUʱ,ʱ
**************************************/
void Delay5us()
{
    _nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
}

/**************************************
ʱ5(STC90C52RC@12M)
ͬĹ,Ҫ˺
1TMCUʱ,ʱ
**************************************/
void Delay5ms()
{
    WORD n = 560;

    while (n--);
}

/**************************************
ʼź
**************************************/
void ADXL345_Start()
{
    SDA = 1;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 0;                    //½
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
}

/**************************************
ֹͣź
**************************************/
void ADXL345_Stop()
{
    SDA = 0;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 1;                    //
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
ڲ:ack (0:ACK 1:NAK)
**************************************/
void ADXL345_SendACK(bit ack)
{
    SDA = ack;                  //дӦź
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
**************************************/
bit ADXL345_RecvACK()
{
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    CY = SDA;                   //Ӧź
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ

    return CY;
}

/**************************************
IIC߷һֽ
**************************************/
void ADXL345_SendByte(BYTE dat)
{
    BYTE i;

    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;              //Ƴݵλ
        SDA = CY;               //ݿ
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    ADXL345_RecvACK();
}

/**************************************
IIC߽һֽ
**************************************/
BYTE ADXL345_RecvByte()
{
    BYTE i;
    BYTE dat = 0;

    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        dat |= SDA;             //               
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    return dat;
}

//******ֽд*******************************************

void Single_Write_ADXL345(uchar REG_Address,uchar REG_data)
{
    ADXL345_Start();                  //ʼź
    ADXL345_SendByte(SlaveAddress);   //豸ַ+дź
    ADXL345_SendByte(REG_Address);    //ڲĴַοpdf22ҳ 
    ADXL345_SendByte(REG_data);       //ڲĴݣοpdf22ҳ 
    ADXL345_Stop();                   //ֹͣź
}

//********ֽڶȡ*****************************************
uchar Single_Read_ADXL345(uchar REG_Address)
{  uchar REG_data;
    ADXL345_Start();                          //ʼź
    ADXL345_SendByte(SlaveAddress);           //豸ַ+дź
    ADXL345_SendByte(REG_Address);                   //ʹ洢Ԫַ0ʼ	
    ADXL345_Start();                          //ʼź
    ADXL345_SendByte(SlaveAddress+1);         //豸ַ+ź
    REG_data=ADXL345_RecvByte();              //Ĵ
	ADXL345_SendACK(1);   
	ADXL345_Stop();                           //ֹͣź
    return REG_data; 
}
//*********************************************************
//
//ADXL345ڲٶݣַΧ0x32~0x37
//
//*********************************************************
void Multiple_read_ADXL345(void)
{   uchar i;
    ADXL345_Start();                          //ʼź
    ADXL345_SendByte(SlaveAddress);           //豸ַ+дź
    ADXL345_SendByte(0x32);                   //ʹ洢Ԫַ0x32ʼ	
    ADXL345_Start();                          //ʼź
    ADXL345_SendByte(SlaveAddress+1);         //豸ַ+ź
	 for (i=0; i<6; i++)                      //ȡ6ַݣ洢BUF
    {
        BUF[i] = ADXL345_RecvByte();          //BUF[0]洢0x32ַе
        if (i == 5)
        {
           ADXL345_SendACK(1);                //һҪNOACK
        }
        else
        {
          ADXL345_SendACK(0);                //ӦACK
       }
   }
    ADXL345_Stop();                          //ֹͣź
    Delay5ms();
}


//*****************************************************************

//ʼADXL345Ҫοpdf޸************************
void Init_ADXL345()
{
   Single_Write_ADXL345(0x31,0x0B);   //Χ,16g13λģʽ
   Single_Write_ADXL345(0x2C,0x08);   //趨Ϊ12.5 οpdf13ҳ
   Single_Write_ADXL345(0x2D,0x08);   //ѡԴģʽ   οpdf24ҳ
   Single_Write_ADXL345(0x2E,0x80);   //ʹ DATA_READY ж
   Single_Write_ADXL345(0x1E,0x00);   //X ƫ ݲԴ״̬дpdf29ҳ
   Single_Write_ADXL345(0x1F,0x00);   //Y ƫ ݲԴ״̬дpdf29ҳ
   Single_Write_ADXL345(0x20,0x05);   //Z ƫ ݲԴ״̬дpdf29ҳ
}
//***********************************************************************
//ʾx
void display_x()
{   float temp;
    dis_data=(BUF[1]<<8)+BUF[0];  //ϳ   
	if(dis_data<0){
	dis_data=-dis_data;
    DisplayOneChar(2,0,'-');      //ʾλ
	}
	else DisplayOneChar(2,0,' '); //ʾո

    temp=(float)dis_data*3.9;  //ݺʾ,鿼ADXL345ŵ4ҳ
    conversion(temp);          //תʾҪ
	DisplayOneChar(0,0,'X');   //0У0 ʾX
    DisplayOneChar(1,0,':'); 
    DisplayOneChar(3,0,qian); 
	DisplayOneChar(4,0,'.'); 
    DisplayOneChar(5,0,bai); 
    DisplayOneChar(6,0,shi); 
	DisplayOneChar(7,0,'g'); 
}

//***********************************************************************
//ʾy
void display_y()
{     float temp;
    dis_data=(BUF[3]<<8)+BUF[2];  //ϳ   
	if(dis_data<0){
	dis_data=-dis_data;
    DisplayOneChar(2,1,'-');      //ʾλ
	}
	else DisplayOneChar(2,1,' '); //ʾո

    temp=(float)dis_data*3.9;  //ݺʾ,鿼ADXL345ŵ4ҳ
    conversion(temp);          //תʾҪ
	DisplayOneChar(0,1,'Y');   //1У0 ʾy
    DisplayOneChar(1,1,':'); 
    DisplayOneChar(3,1,qian); 
	DisplayOneChar(4,1,'.'); 
    DisplayOneChar(5,1,bai); 
    DisplayOneChar(6,1,shi);  
	DisplayOneChar(7,1,'g');  
}

//***********************************************************************
//ʾz
void display_z()
{      float temp;
    dis_data=(BUF[5]<<8)+BUF[4];    //ϳ   
	if(dis_data<0){
	dis_data=-dis_data;
    DisplayOneChar(10,1,'-');       //ʾλ
	}
	else DisplayOneChar(10,1,' ');  //ʾո

    temp=(float)dis_data*3.9;  //ݺʾ,鿼ADXL345ŵ4ҳ
    conversion(temp);          //תʾҪ
	DisplayOneChar(10,0,'Z');  //0У10 ʾZ
    DisplayOneChar(11,0,':'); 
    DisplayOneChar(11,1,qian); 
	DisplayOneChar(12,1,'.'); 
    DisplayOneChar(13,1,bai); 
    DisplayOneChar(14,1,shi); 
	DisplayOneChar(15,1,'g');  
}


//*********************************************************
//**************
//*********************************************************
void main()
{ 
  uchar devid;
  delay(500);	                   //ϵʱ		
  InitLcd();                      //ҺʼADXL345
  Init_ADXL345();                 //ʼADXL345
  devid=Single_Read_ADXL345(0X00);//Ϊ0XE5,ʾȷ
  while(1)                         //ѭ
  { 
    Multiple_Read_ADXL345();       //ݣ洢BUF
    display_x();                   //---------ʾX
    display_y();                   //---------ʾY
    display_z();                   //---------ʾZ
    delay(200);                    //ʱ            
  }
} 
